Skip to content
Snippets Groups Projects
Commit 81bf537b authored by jdh8d's avatar jdh8d
Browse files

bug fixes and first tested version of eh-rewriting.

Former-commit-id: efd748477c76d5e0862dbfd29b7a7fae5a7fca8c
parent 7141a2b9
No related branches found
No related tags found
No related merge requests found
......@@ -18,6 +18,7 @@ c++_examples/newdelete4.cpp -text
c++_examples/newdelete5.cpp -text
c++_examples/newdelete6.cpp -text
c++_examples/simple_throw.cpp -text
c++_examples/testit.sh -text
c++_examples/throw.cpp -text
cgc_spri/Makefile -text
cgc_spri/spawn_with_spri_open.c -text
......
#!/bin/bash
compare()
{
env $1 ./a.out > good.txt 2>&1
env $1 ./xxx > xform.txt 2>&1
cmp good.txt xform.txt > /dev/null 2>&1
if [ $? != 0 ]; then
echo "Failed test: $1";
diff good.txt xform.txt
exit 2
fi
}
src_files="simple_throw.cpp throw.cpp"
options="-Os -O0 -O1 -O2 -O3"
throws="THROW_INT THROW_CHAR THROW_FLOAT"
for src in $src_files
do
echo "Trying $src"
for option in $options
do
echo "With $option"
g++ $option $src
rm -Rf peasoup_executable_direc*
EHIR_VERBOSE=1 $PSZ ./a.out ./xxx --step-option fill_in_indtargs:--split-eh-frame --step-option zipr:'--add-sections true'
compare
for throw in $throws
do
compare $throw=1
done
done
done
......@@ -120,5 +120,6 @@ CREATE TABLE #EHCS#
(
ehcs_id integer, -- id of this object.
tt_encoding integer, -- the encoding of the type table.
has_cleanup integer, -- whether this callsite has cleanups, even if the type table is empty.
lp_insn_id integer -- the landing pad instruction's id.
);
......@@ -4,7 +4,7 @@ infile=$1
addr=$2
outfile=$3
gcc $infile -nostdlib -Wl,--section-start -Wl,eh_frame_hdr=$addr -Wl,-e -Wl,0x1000 -Wl,--build-id=none -Wl,-T -Wl,${PEASOUP_HOME}/tools/eh_frame_tools/eh_frame.ls -o $outfile || exit
gcc $infile -nostdlib -Wl,--section-start -Wl,eh_frame_hdr=$addr -Wl,-e -Wl,0x1000 -Wl,--build-id=none -Wl,-T -Wl,${PEASOUP_HOME}/tools/eh_frame_tools/eh_frame.ls -o $outfile -Wl,-Map,$outfile.map || exit
#eu-readelf -S ./a.out
objcopy --rename-section eh_frame_hdr=.eh_frame_hdr --rename-section eh_frame=.eh_frame --rename-section gcc_except_table=.gcc_except_table $outfile
#eu-readelf -S -w ./b.out
......
0% Loading or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment